/*
    EF plugin SDK
    komipilowa mozna w DevC++ 4.9.9.2.
    Nalezy dodac tylko jakiegos switcha zeby nie manglowaly sie nazwy
*/
#define PLUGIN_NAME "Enemy Flag Server Plugin"
#define PLUGIN_ENGINE_VERSION 2
#define PLUGIN_BNAME "Wrong Plugin Engine Version"
#define PING_NONE 65535
#define PING_BOT 65534
#include <stdio.h>
typedef unsigned char Byte;
typedef char* PChar;
typedef int Integer;
typedef unsigned char Boolean;
typedef void* Pointer;
#define procedure void
#define EXPORT __stdcall __declspec(dllexport)
#define IMPORT __stdcall
#define True 1
#define False 0
typedef struct
{
      PChar Name;
    Byte Status;
}TLogin;

typedef struct
{
    PChar IP;
    Boolean Bot;
    Integer Ping;
    TLogin Login;
    PChar Name;
    Byte Color;
    Boolean Spectator;
    Byte Team;
    Integer Time;
}TClientData;

typedef procedure IMPORT (TExecLine)(PChar);/*PChar = komenda, ktra zostanie wywoana*/
typedef procedure IMPORT (TSetString)(Integer, PChar, Byte);/* Integer = numer gracza ktremu wywietlamy wiadomo, PChar = tre, Byte = kolor od 0 do 16 */
typedef procedure IMPORT (TSetWindow) (Integer, PChar);/* Integer, PChar */
typedef TClientData IMPORT (TGetClientData)(Integer);/* Integer */
typedef procedure IMPORT (TToggleClientSpectator)(Integer);/* Integer */
typedef procedure IMPORT (TChangeClientTeam)(Integer, Byte);/* Integer, Byte */



TExecLine *ExecLine;
TSetString *SetString;
TSetWindow *SetWindow;
TGetClientData *GetClientData;
TToggleClientSpectator *ToggleClientSpectator;
TChangeClientTeam *ChangeClientTeam;



PChar EXPORT OnLoad(Byte Version, PChar GameVersion)
{
if(Version==PLUGIN_ENGINE_VERSION)
return PLUGIN_NAME;
return PLUGIN_BNAME;
}

procedure EXPORT OnLoadEx(TExecLine *PExecLine, TSetString *PSetString, TSetWindow *PSetWindow, TGetClientData *PGetClientData,
  TToggleClientSpectator *PToggleClientSpectator, TChangeClientTeam *PChangeClientTeam)
{
ExecLine = PExecLine;
SetString = PSetString;
SetWindow = PSetWindow;
GetClientData = PGetClientData;
ToggleClientSpectator = PToggleClientSpectator;
ChangeClientTeam = PChangeClientTeam;
ExecLine("say Plugin loaded successfully!");
}
procedure EXPORT OnUnload()
{
}
procedure EXPORT OnProcess()
{
}
procedure EXPORT OnClientConnect(Integer ClNum)
{
}
procedure EXPORT OnClientDisconnect(Integer ClNum)
{
}
PChar EXPORT OnClientCustomCommand(Integer ClNum, PChar CustomCommand)
{
return NULL;
}
Boolean EXPORT OnClientToggleSpectator(Integer ClNum, Boolean SrcSpectator, Boolean DestSpectator)
{
return True;
}
Boolean EXPORT OnClientChangeTeam(Integer ClNum, Byte SrcTeam, Byte DestTeam)
{
return True;
}
Boolean EXPORT OnClientCanPlay(Integer ClNum)
{
return True;
}
procedure EXPORT OnGameStart(Byte ClCount, Integer *ClArray, Integer ArrayPad, PChar Map)/* ArrayPad mozna zignorowa, ale musi tu by, inaczej nazwa mapy si nie wczyta */
{
}
procedure EXPORT OnGameEnd()
{
}
procedure EXPORT OnPlayerDestroy(Integer DestroyClNum, Integer EnemyClNum)
{
}
procedure EXPORT OnEndTurn(Integer ClNum, Integer TurnNum)
{
}
